

import java.lang.Object;

import java.io.BufferedWriter;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;

import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

import java.lang.reflect.Method;

import java.text.SimpleDateFormat;
import java.util.Calendar;

import burp.IBurpExtenderCallbacks;


/**
 *
 * @author invalidPacket
 */
public class BurpExtender implements IBurpExtender {
    
	private String ProcessorPath="";
	private String EditorPath="";
	private String LogPath="";
	public boolean canForward=true;
	
	/**
     * Causes burp proxy to follow the current interception rules to determine
     * the appropriate action to take for the message.
     */
    public final static int ACTION_FOLLOW_RULES = 0;
    /**
     * Causes burp proxy to present the message to the user for manual
     * review or modification.
     */
    public final static int ACTION_DO_INTERCEPT = 1;
    /**
     * Causes burp proxy to forward the message to the remote server.
     */
    public final static int ACTION_DONT_INTERCEPT = 2;
    /**
     * Causes burp proxy to drop the message and close the client connection.
     */
    public final static int ACTION_DROP = 3;

    private static String LOG_PATH;
    private static String LOG_NAME = "BurpLogFile_#.txt";
    private FileWriter fstream;
    private BufferedWriter out;
    public static final String DATE_FORMAT_NOW = "yyyyMMdd_HHmm";

    /**
     * Creates a new instance of BurpExtender
     */
    public BurpExtender() {
        
    }
 
    private void writeFile(byte[] btData,String fullpath){
      	 try {
   		 File output = new File(fullpath);
   		 FileOutputStream fos = new FileOutputStream(output);
   		 
   		 ByteArrayInputStream inp = new ByteArrayInputStream(btData);
   
   		 int data;
   		
   		 while((data=inp.read()) !=-1)
   		  fos.write(data);
   		 fos.close();
              
        } catch (IOException ex) {
            ex.printStackTrace();
        }
   }
   private byte[] fixProxyHeader(byte[] message){
	     String strMessage = new String(message);
	     String newMessage,Host,newHeaders,Methud,line;
		 int startPayload = strMessage.indexOf("\r\n\r\n");
		 
		 Host=strMessage.split("ost: ")[1].split("\r\n")[0];
		 Methud=strMessage.split(" ")[0];
		 line=strMessage.split(Methud)[1].split("\r\n")[0];
		 line=line.substring(1);
		 if (startPayload==-1){
			 newHeaders=Methud+" http://"+Host+line+strMessage.substring(strMessage.indexOf("\r\n"));
			 return (newHeaders.getBytes());
		 }else
		 {
			 newMessage=Methud+" http://"+Host+line+strMessage.substring(strMessage.indexOf("\r\n"),startPayload+4);

			int startPayLoadIndex = startPayload+4 ;
				
			byte[] header = newMessage.getBytes();
			byte[] mes =new byte[message.length-startPayload-4+header.length];
			
			
			int i = 0 , j =0 ;
						
			try{
			for (i=0  ; i<header.length ; i++)
				mes[i] = header[i];
				
			for (  j = startPayLoadIndex ; i<mes.length ; i++ , j++)
						mes[i] = message[j];
				}catch (Exception e){
					System.out.println("Exception"+e);
				}
				return mes;
		 }

	   
	   
   } 
   
   
    public byte[] processProxyMessage(int messageReference, boolean messageIsRequest, String remoteHost, int remotePort, boolean serviceIsHttps, String httpMethod, String url, String resourceType, String statusCode, String responseContentType, byte[] message, int[] action) {
        
    	this.EditorPath=ed.Editor.getText();
    	this.ProcessorPath=ed.ProcessorFile.getText();
    	this.LogPath=ed.FlowDir.getText();
    	
    	if ((!ed.el)&&(!ed.auto))
    		return message;
    	
    	if (ed.getProxy())
    		message=fixProxyHeader(message);

        String strMessage = new String(message);
		
		int startPayload = strMessage.indexOf("\r\n\r\n");

		int startPayLoadIndex = startPayload+4 ;
		
		byte[] byteOrigMessageContent =new byte[message.length-startPayload-4];
		
		int i = 0 , j =0 ;
				
		try{
			for ( i = startPayLoadIndex, j = 0 ; j<byteOrigMessageContent.length ; i++ , j++)
				byteOrigMessageContent[j] = message[i];
		}catch (Exception e){
			System.out.println("Exception"+e);
		}
		
		
		if (ed.FlowDir.getText()!="")
			LOG_PATH=ed.FlowDir.getText()+File.separatorChar;
		String ty ="";
		if (messageIsRequest)
			ty="Request";
		else
			ty="Response";
		byte[] Returned = byteOrigMessageContent;

		String messageFile = LOG_PATH+messageReference+'_'+ty+".raw";
		
		writeFile(message,messageFile);
		
		if ((ed.auto)&&(!messageIsRequest)&&(ed.AutoFile.getText()!="")&&(ed.ProcessorFile.getText()!=""))
			{
			executeProcessor(messageFile,ed.AutoFile.getText());
			
			}
		
		if( ((ed.rq && messageIsRequest) || (ed.rs && !messageIsRequest)) && 
				ed.Editor.getText()!="" && action[0] != ACTION_DONT_INTERCEPT){
		executeEditor(messageFile);
		
		}
		Returned = fileToPayload(messageFile);	

			writeFile(Returned,messageFile);
		
			return Returned;
	
    	
    }
    private void executeProcessor(String OriginalResponse,String RecordedResponse){
    	String fullname = RecordedResponse;
		String name = fullname.substring(fullname.lastIndexOf(File.separatorChar)+1);
		String fullpath =fullname.substring(0,fullname.lastIndexOf(File.separatorChar));
		int counter = new Integer(name.split("_Response")[0]);		
				try{
						FileReader f = new FileReader (fullname);
						if (f.ready())
						{	
							f.close();
			
							int i = ed.getCounter();
							counter++;
							ed.AutoFile.setText(fullpath+File.separatorChar+(counter)+"_"+name.split("_")[1]);
							Process p = Runtime.getRuntime().exec(this.ProcessorPath+" "+OriginalResponse+" "+" "+RecordedResponse);
							p.waitFor();
							
						}
						
					}
				catch (Exception f){
					System.out.println("Exception\n"+f);	
				}
				
		
    }
    public void applicationClosing() {
        try {
            out.flush();
        } catch (IOException ex) {
            ex.printStackTrace();
        }
        try {
            out.close();
        } catch (IOException ex) {
            ex.printStackTrace();
        }
        try {
            fstream.close();
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }

    public void registerHttpRequestMethod(Method makeHttpRequestMethod, Object makeHttpRequestObject) {
      
    }

    public void setCommandLineArgs(String[] args) {
    	
       for (int i = 0; i< args.length; i++)
       {
    	   if(args[i].toLowerCase().startsWith("editor="))
    		   EditorPath=args[i].toLowerCase().split("editor=")[1];
    	   else if (args[i].toLowerCase().startsWith("logpath="))
    		   LogPath=args[i].toLowerCase().split("logpath=")[1];
    	   else if (args[i].toLowerCase().startsWith("processor="))
    		   ProcessorPath=args[i].toLowerCase().split("processor=")[1];
       }
       
       String mydir ="" ;
       if(LogPath=="")
    	   mydir = System.getProperty ("user.dir");
       else
    	   mydir = LogPath;
       
       ed = new BelchGUI();
       ed.run(mydir,EditorPath,ProcessorPath);
       LOG_PATH = mydir.concat(File.separator).concat(LOG_NAME.replace("#",getTimeStamp()));
   
    }
public void executeEditor(String file){
	Runtime r = Runtime.getRuntime();
	try {
		Process ps = r.exec(ed.Editor.getText()+ " "+ file);
		ps.waitFor();
	} catch (IOException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	} catch (InterruptedException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	}
	
}

public byte[] fileToPayload (String file){
	
	try {
  		 File input = new File(file);
  		 FileInputStream fis = new FileInputStream(input);
  		 
  		 ByteArrayOutputStream baos = new ByteArrayOutputStream();
  
  		 int data;
  		
  		 while((data=fis.read()) !=-1)
  			baos.write(data);
  		baos.close();
  		
  		return baos.toByteArray();
              
       } catch (IOException ex) {
           ex.printStackTrace();
       }
  
	return null;
}
	public void registerExtenderCallbacks(IBurpExtenderCallbacks callbacks) {
		// TODO Auto-generated method stub
		
	}
	private String getTimeStamp(){
	    Calendar cal = Calendar.getInstance();
	    SimpleDateFormat sdf = new SimpleDateFormat(DATE_FORMAT_NOW);
	    return sdf.format(cal.getTime());
	}
	public BelchGUI ed;

}
